//+------------------------------------------------------------------+
//|                                            Bollinger Candles.mq4 |
//|                                                     by alToronto |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, alToronto"
#property link      "http://www.forex-tsd.com/suggestions-trading-systems/42818-my-bollinger-trend-following-system-mtf.html"
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Green//wick
#property indicator_color2 Red//wick
#property indicator_color3 Green//candle
#property indicator_color4 Red//candle
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3


//---- bollinger/ema settings
extern int	BollingerPeriod      = 240;
extern int  BollingerDeviation   = 1;
extern int  emaPeriod            = 13;

//---- input parameters
extern int	BarWidth			= 1,
				CandleWidth		= 2;

//---- buffers
double Bar1[],
		 Bar2[],
		 Candle1[],
		 Candle2[];
		 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
	IndicatorShortName("Bollinger Candles:("+	BollingerPeriod+")");
	IndicatorBuffers(4);
	SetIndexBuffer(0,Bar1);
	SetIndexBuffer(1,Bar2);				
	SetIndexBuffer(2,Candle1);
	SetIndexBuffer(3,Candle2);
	SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth);

	return(0);
}

//+------------------------------------------------------------------+
double bollingerUp (int i = 0)	{
   return(iBands(NULL,0,BollingerPeriod,BollingerDeviation,0,PRICE_CLOSE,MODE_UPPER,i));
}

double bollingerDn (int i = 0)	{
   return(iBands(NULL,0,BollingerPeriod,BollingerDeviation,0,PRICE_CLOSE,MODE_LOWER,i));
}

double ema (int i = 0)	{
   return(iMA(NULL,0,emaPeriod,0,MODE_EMA,PRICE_OPEN,i));
}



//+------------------------------------------------------------------+
void SetCandleColor(int col, int i)
{
	double high,low,bodyHigh,bodyLow;


	{
		bodyHigh = MathMax(Open[i],Close[i]);
		bodyLow  = MathMin(Open[i],Close[i]);
		high		= High[i];
		low		= Low[i];
	}

	Bar1[i] = low;	Candle1[i] = bodyLow;
	Bar2[i] = low;	Candle2[i] = bodyLow;
	

	switch(col)
	{
		case 1: 	Bar1[i] = high;	Candle1[i] = bodyHigh;	break;
		case 2: 	Bar2[i] = high;	Candle2[i] = bodyHigh;	break;
	
	}
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
	for(int i = MathMax(Bars-1-IndicatorCounted(),1); i>=0; i--)
	{
		double	bolUp	      = bollingerUp(i);
		double	bolDn	      = bollingerDn(i);
		double	emaFilter   = ema(i);
				

				if((Open[i] > emaFilter) && (Open[i] > bolUp))		SetCandleColor(1,i);
		else	if((Open[i] < emaFilter) && (Open[i] < bolDn))		SetCandleColor(2,i);
		
	}
	

	return(0);
}
//+------------------------------------------------------------------+

